import 'dart:convert';

import 'package:flutter/material.dart';
import 'package:loyalty_management_tool/bloc/common_widgets/rewards_widget.dart';
import 'package:loyalty_management_tool/bloc/rewards_module/pages/postrecieverlistpage.dart';
import 'package:loyalty_management_tool/models/rewards_list_response.dart';
import 'package:loyalty_management_tool/utils/custom_app_bar.dart';
import 'package:loyalty_management_tool/utils/customcard.dart';
import 'package:loyalty_management_tool/utils/localization.dart';

import '../../../NetworkFile/calls.dart';
import '../../../models/create_post_payload.dart';
import '../../../models/create_rewards_reponse.dart';
import '../../../models/postcreate.dart';
import '../../../models/postreceiver.dart';
import '../../../utils/basicInfo.dart';

class RewardsDetailPage extends StatefulWidget {
  final RewardsItem item;
  final Function(RewardsItem? item) editCallBack;
  final Function(int? id) deleteCallBack;

  const RewardsDetailPage({Key? key,
    required this.item,
    required this.editCallBack,
    required this.deleteCallBack})
      : super(key: key);

  @override
  RewardsDetailPageState createState() => RewardsDetailPageState();
}

class RewardsDetailPageState extends State<RewardsDetailPage> {

  BasicInfo? basicInfo = BasicInfo();
  @override
  Widget build(BuildContext context) {
    return Scaffold(
        appBar: appAppBar().getCustomAppBar(
          context,
          appBarTitle: AppLocalizationsRewards.of(context)!.translate("detail"),
          onBackButtonPress: () {
            Navigator.pop(context);
          },
        ),
        body: SingleChildScrollView(
          child: Column(
            mainAxisSize: MainAxisSize.min,
            children: [
              RewardsWidget(
                isDetailPage: true,
                item: widget.item,
                deleteCallBack: (id) {
                  widget.deleteCallBack(id);
                },
                editCallBack: (item) {
                  widget.editCallBack(widget.item);
                },
              ),
              appCard(child: ListTile(
                onTap: () {
                  Navigator.of(context)
                      .push(MaterialPageRoute(
                      builder: (context) =>
                          PostReceiverListPage(
                            type: "post",
                            recipientType: widget.item.recipientType,
                            recipientDetails: widget.item.recipientDetails,
                            payload: PostCreatePayload(),
                            callBack: () {

                            },
                          )))
                      .then((value) {
                    if (value != null && value["payload"]!=null) {
                    //  Navigator.of(context).pop({'payload': value["payload"]});

                      var data= value["payload"] as PostCreatePayload;
                      widget.item.recipientType=(data.postRecipientType!.cast<String>()).toSet().toList();
                      widget.item.recipientDetails=(data.postRecipientDetails!.cast<NormalReceivers2>()).toSet().toList();
                      editPost(jsonEncode(widget.item));

                    }
                  });
                },

                title: const Text("Target Audience"),
                trailing: IconButton(
                  icon: const Icon(Icons.keyboard_arrow_right_sharp),
                  onPressed: () {},),

              ))
            ],
          ),
        ));
  }
  Future<void> editPost(String body) async {
    var res = await Calls().call(
        body, context, basicInfo!.editReward );
    var data = CreateRewardResponse.fromJson(res);
    if (data.statusCode == basicInfo!.statusCode) {

    }
  }
  PostCreatePayload getPostPayload() {
    PostCreatePayload payload = PostCreatePayload();
    ContentMetaCreate contentMetaCreate=ContentMetaCreate();
    contentMetaCreate.meta= widget.item.subtitle;
    contentMetaCreate.title= widget.item.title;
    payload.postId = widget.item.id;
    payload.id = null;
    payload.contentMeta =contentMetaCreate;
    payload.postOwnerType =  "person";
    payload.postOwnerTypeId =  widget.item.createdByUserId;
    payload.postCreatedById = widget.item.createdByUserId;
    payload.postBusinessId =widget.item.businessId;
    payload.postType ="feed";
    payload.postStatus = 'posted';
    payload.postCategory = 'normal';
    payload.mediaDetails = widget.item.mediaUrls != null &&
    widget.item.mediaUrls!.isNotEmpty
    ? widget.item.mediaUrls
        : [];


    return
    payload;
  }
}
