import 'dart:async';

import 'package:flutter/services.dart';
import 'package:loyalty_management_tool/utils/basicInfo.dart';

class FoopLoyaltyPlugin {
  static const MethodChannel _channel =
      MethodChannel('loyalty_management_tool');

  static Future<String?> get platformVersion async {
    final String? version = await _channel.invokeMethod('getPlatformVersion');
    return version;
  }

  static setBasicInfo(BasicInfo bI){
    BasicInfo basicInfo = BasicInfo();
    basicInfo.address = bI.address ;
    basicInfo.userId = bI.userId ;
    basicInfo.businessId = bI.businessId ;
    basicInfo.baseUrl = bI.baseUrl ;
    basicInfo.baseUrlWithoutHttp = bI.baseUrlWithoutHttp ;
    basicInfo.currencySymbol = bI.currencySymbol ;
    basicInfo.accountId = bI.accountId ;
    basicInfo.gst = bI.gst ;
    basicInfo.userName = bI.userName;
    basicInfo.appLanguageCode = bI.appLanguageCode ;
    basicInfo.userImage = bI.userImage ;
    basicInfo.timeFormat = bI.timeFormat ;
    basicInfo.token = bI.token ;
    basicInfo.slug = bI.slug ;
    basicInfo.dateFormat = bI.dateFormat ;
    basicInfo.googleMapKey = bI.googleMapKey ;
    basicInfo.googleTransltionKey = bI.googleTransltionKey ;
    basicInfo.callBack = bI.callBack ;
  }
}
